#include "TouWenJian.h"

unsigned int reverse2(unsigned int w){
	return w>>8|w<<8;
}

void USB_XJCQ(unsigned char DiZhi,unsigned char ZhiLing){//USB写寄存器
	while(USBADR&0x80);
	USBADR=DiZhi;
	USBDAT=ZhiLing;
}

void USB_DJCQ_(unsigned char DiZhi){//USB读寄存器
	while(USBADR&0x80);
	USBADR=DiZhi;
	while(USBADR&0x80);
}

void USB_X_FIFO_C_(unsigned char D,unsigned char code*S,unsigned char C){//USB写FIFO
	while(C--)USB_XJCQ(D,*S++);
}

void USB_D_FIFO(unsigned char D,unsigned char pdata*S){//USB读FIFO
	unsigned char a;
	USB_DJCQ(COUNT0);
	a=USBDAT;
	while(a--){
		USB_DJCQ(D);
		*S++=USBDAT;
	}
}

void USB_ChuShiHua(){//USB初始化
//	USB_XJCQ(INTRIN1E,0x01);
//	USB_XJCQ(INTROUT1E,0x02);
//	USB_XJCQ(INTRUSBE,0x07);
//	USB_XJCQ(POWER,0x01);
}

void CK3_DMA(unsigned char D,unsigned char C){//串口3DMA发送数据
	while(!(DMA_UR3T_STA&1));
	DMA_UR3T_STA=0;
	DMA_UR3T_TXAL=D;
	DMA_UR3T_AMT=C-1;
	DMA_UR3T_CR=0xC0;
}

void CL_INTRUSB(){//USB电源中断
	USB_DJCQ(INTRUSB);
	if(USBDAT&RSTIF){//USB复位信号
		USB_XJCQ(FADDR,0);
		USB_XJCQ(INCSR1,0x48);
		USB_XJCQ(OUTCSR1,0x90);
	}
}

void CL_INTRIN1(){//USB端点IN中断
	USB_DJCQ(INTRIN1);
	if(USBDAT&EP0IF){//端点0
		SETUP Setup;
		USB_XJCQ(INDEX,0);
//		USB_DJCQ(CSR0);
//		if(USBDAT&STSTL)USBDAT&=~STSTL;//清除STALL信号发送完成标记
//		if(USBDAT&SUEND)USBDAT|=SSUEND;//清除SETUP安装包结束标记
//		USB_XJCQ(CSR0,USBDAT);
		USB_D_FIFO(FIFO0,(unsigned char pdata*)&Setup);
		CK3_DMA((unsigned char)&Setup,sizeof(SETUP));
		switch(Setup.bmRequestType){
			case ZBS:
				switch(Setup.bRequest){
					case SET_ADDRESS://设置地址
						USB_XJCQ(FADDR,Setup.wValueL);
						USB_XJCQ(CSR0,SOPRDY|DATEND);
					break;
				}break;
			case SBS:
				switch(Setup.bRequest){
					case GET_DESCRIPTOR://请求传输结构数据
						switch(Setup.wValueH){
							case DEXICE:{//设备描述符
								DEVICEDESC Devicedesc={sizeof(DEVICEDESC),DEXICE,0x0002,0x00,0x00,0x00,0x40,0xBF34,0x8888,0x0001,1,2,0,1};
								USB_XJCQ(INDEX,0);
								USB_X_FIFO_C(FIFO0,Devicedesc);
								USB_XJCQ(CSR0,IPRDY);
							}break;
							case CONFIGURATION:{//配置描述符
								DESCRIPTOR Desc={sizeof(CONFIGDESC),CONFIGURATION,QJGC(DESCRIPTOR),1,1,0,0x80,50,//配置描述符
																 sizeof(INTERFDESC),INTERFACE,0,0,1,0x03,0x01,0x02,0,//接口描述符
																 sizeof(HIDDESC),HID,0x0101,0x00,1,0x22,0x3200,//HID描述符
																 sizeof(ENDPOIDESC),ENDPOINT,0x81,0x03,0x4000,0x0A,//端点描述符
																};
								USB_XJCQ(INDEX,0);
								USB_X_FIFO_C(FIFO0,Desc);
								USB_XJCQ(CSR0,SOPRDY|IPRDY);
							}break;
							case STRING:{//字符串描述符
								
							}break;
						}break;
				}break;
		}
	}
}

USB_TongXun()interrupt 25{//USB通讯
	CL_INTRUSB();
	CL_INTRIN1();
	USB_DJCQ(INTROUT1);
}